/*
* Readyroom Blocker for Amx by Seraph
*
*	This plugin prevents people from going into the readyroom except under the following circumstances:
*	- An admin (with kick access) forces a player to go to the alien team, the marine team, or into the readyroom
*	- You are already in the readyroom, or are spectating
*	- The opposing team is 2 or more players down
*	  i.e. You're on the marine team with 10 people, and the aliens have only 8. It will let one person go into
*	    the readyroom from the marine team (it won't let anymore marines go into the readyroom)
*
* comment out '#define MESSAGE' if you don't want to display a message when a person tries to go into the readyroom
*
* thanks to 'Zoc' for the Metamod plugin of this and for the idea
*
* thanks to 'cgountanis' for the switch teams code
*
* thanks to 'mahnsawce' and 'devicenull' for helping me fixing errors with this plugin
*
*/

#include <amxmodx>
#include <amxmisc>
#include <ns2amx>
#include <ns2amxhelpers>

// Comment out to disable readyroom blocking messages
#define MESSAGE

public plugin_init()
{
	register_plugin ("Readyroom Blocker", "1.3", "Seraph")

	register_cvar("sv_rrblock", "1") // Set to 0 to disable RR blocking


	register_clcmd("readyroom", "blockrr")
	register_impulse(5, "blockrr")

	register_concmd("amx_alien","SwitchAlien",ADMIN_KICK,"<authid, nick or #userid>")
	register_concmd("amx_marine","SwitchMarine",ADMIN_KICK,"<authid, nick or #userid>")

	register_concmd("amx_rr","SwitchRR",ADMIN_KICK,"<authid, nick or #userid>")
	register_concmd("amx_readyroom","SwitchRR",ADMIN_KICK,"<authid, nick or #userid>")
	register_concmd("amx_f4","SwitchRR",ADMIN_KICK,"<authid, nick or #userid>")

	return PLUGIN_CONTINUE
}

public blockrr(id)
{
	if ( (get_user_flags(id) & ADMIN_KICK) || (!get_cvar_num("sv_rrblock")) )
		return PLUGIN_CONTINUE

	if ( checkTeams(id) )
		return PLUGIN_CONTINUE

#if defined MESSAGE
	client_print(id, print_chat, "Readyroom is disabled")
#endif

	return PLUGIN_HANDLED
}

public SwitchAlien(id, level, cid)
{
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	new arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, 2)

	if (player != 0)
	{
		engclient_cmd(player, "readyroom")
		engclient_cmd(player, "jointeamtwo")
		client_print(player, print_chat, "You where transfered to the Aliens team!")
	}
	return PLUGIN_HANDLED
}

public SwitchMarine(id, level, cid)
{
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	new arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, 2)

	if (player != 0)
	{
		engclient_cmd(player, "readyroom")
		engclient_cmd(player, "jointeamone")
		client_print(player, print_chat, "You where transfered to the Marines team!")
	}
	return PLUGIN_HANDLED
}

public SwitchRR(id, level, cid)
{
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	new arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, 2)

	if (player != 0)
	{
		engclient_cmd(player, "readyroom")
		client_print(player, print_chat, "You where transfered to the Readyroom!")
	}
	return PLUGIN_HANDLED
}

public checkTeams(id)
{
	new marineC, alienC, pteam
	for (new i=0;i<=32;i++) {
		if (!is_user_connected(i)) continue
		pteam = pev(i,pev_team)
		if (pteam == 1)
			marineC++
		if (pteam == 2)
			alienC++
	}

	new iMarineDif = marineC - alienC
	new iAlienDif =  alienC - marineC

	new team = pev(id, pev_team)

	// lets you go to readyroom if you are on a team with a difference of 2 or more players 
	// also lets you go back into the readyroom if you are spectating or already 
	// in the RR (like if you are stuck in a secret room)
	if (team == 1) // marines
	{
		if (iMarineDif > 1)
			return 1
		else
			return 0
	} else if (team == 2) { // aliens
		if (iAlienDif > 1)
			return 1
		else
			return 0
	} else if (team == 0) { // RR or spectating
		return 1
	}
	
	return 0
}